(*******************************************************************)
(* Bildschirm aus Datei laden und drucken                          *)
(*******************************************************************)

PROGRAM PrintScreenFile;

(*$I KERNEL.INC*)
(*$I DISKETTE.INC*)

CONST
    bell  = #7;

VAR
    ch     : CHAR;
    name   : Strg_14;
    drucke : (Fett, Nicht, Schmal, Hoch);


FUNCTION GetFilename: CHAR;
VAR z: BYTE;
    jn: CHAR;
BEGIN
  Write('(Die Endung .PIC wird automatisch angeh{ngt): ');
  REPEAT
    Write('Dateiname: ');
    Readln(name);
    FOR z:=1 TO Length(name) DO name(.z.) := UpCase(name(.z.));
    name := name + '.PIC';
    Writeln;
    Writeln('Name: ',name);
    Writeln;
    Writeln('Korrekt? (J=Ja N=Nein X=Ende)');
    Read(kbd,jn); Writeln;
    jn:=UpCase(jn);
    IF jn='X' THEN ch:='X';
  UNTIL (jn='J') OR (jn='X');

  GetFilename:=jn;
END;


PROCEDURE Laden;
BEGIN
  ClrScr;
  LoadScreen(name);
  Write(bell);
  REPEAT UNTIL KeyPressed;
END;


PROCEDURE Drucken;

CONST
        ESC = #27;       DZ = 'L';
        TAB = #9;
VAR
        b,i,j,k,j4,j8   : INTEGER;
        iz              : ARRAY(.0..719.) OF BYTE;
        pixelValue      : INTEGER;


  PROCEDURE drf;

  VAR i : INTEGER;

  BEGIN
    WRITE(LST,ESC,DZ,chr(Lo(720)),chr(Hi(720)));
    FOR i:= 0 to 719 DO
      WRITE(LST,CHR(iz(.i.)));
    WRITE(LST,ESC,chr(51),chr(1));     (* Zeilenvorschub 1/216 Zoll *)
    WRITELN(LST);
    WRITE(LST,ESC,DZ,chr(Lo(720)),chr(Hi(720)));
    FOR i:= 0 to 719 DO
      WRITE(LST,CHR(iz(.i.)));
    WRITE(LST,ESC,chr(65),chr(8));     (* Zeilenvorschub 8/72 Zoll  *)
    WRITELN(LST);
  END; (* drf *)


  PROCEDURE drs;

  VAR i : INTEGER;

  BEGIN
    WRITE(LST,ESC,DZ,chr(Lo(720)),chr(Hi(720)));
    FOR i:= 0 to 719 DO
      WRITE(LST,CHR(iz(.i.)));
    WRITELN(LST);
  END; (* drs *)


BEGIN
  WRITELN(LST);
  WRITE(LST,ESC,chr(65),chr(8));  (* Zeilenabstand 8/72 Zoll *)
  IF drucke = Schmal then BEGIN
    FOR j:= 0 TO 31 DO BEGIN (* 39 *)
      j8:= j*8;
      FOR i:= 0 TO 719 DO BEGIN
        b:= 0;
        FOR k:= j8 TO j8+7 DO BEGIN
          IF DotColor(i,k) THEN
            pixelValue := 1
          ELSE
            pixelValue := 0;
          b:= b+b+pixelValue;
        END;
        iz(.i.):= b;
      END;
      drs;
    END;
  END
  ELSE BEGIN
    FOR j:= 0 TO 62 DO BEGIN
      j4:= j*4;
      FOR i:= 0 TO 719 DO BEGIN
        b:= 0;
        FOR k:= j4 TO j4+3 DO BEGIN
          IF DotColor(i,k) THEN
            pixelValue := 1
          ELSE
            pixelValue := 0;
          b:= b+b+pixelValue;
          b:= b+b+pixelValue;
        END;
        iz(.i.):= b;
      END;
      IF drucke = Hoch then drs;
      IF drucke = Fett then drf;
    END;
  END;
  WRITE(LST,ESC,chr(50));         (* Zeilenabstand 1/6 Zoll *)
  WRITELN(LST);
END; (* Drucken *)


BEGIN (* Hauptprogramm *)
  GraphInit;
  REPEAT
    ClrScr;
    Writeln('Bildschirmdatei laden, anzeigen und drucken');
    Writeln;
    Writeln('Wenn die Datei vollst{ndig geladen ist, ert|nt ein Signal. Dann bitte eine Taste dr}cken,');
    Writeln('damit der Druckvorgang startet.');
    Writeln;

    Writeln('A - Nur anzeigen, nicht drucken');
    Writeln('S - Schmal drucken');
    Writeln('H - Hoch   drucken');
    Writeln('F - Fett   drucken');
    Writeln;
    Writeln('X - Ende');

    Read(kbd,ch);
    ch := UpCase(ch);
    Writeln;

    IF ch <> 'X' THEN BEGIN
      Writeln('Wie hei~t die Bilddatei, die geladen werden soll?');
      IF GetFilename='J' THEN BEGIN
        Laden;

        IF ch <> 'A' THEN BEGIN
          case ch of
            'S': drucke := Schmal;
            'H': drucke := Hoch;
            'F': drucke := Fett;
          end;

          Drucken;
        END;
      END;
    END;
  UNTIL ch = 'X';

  ShowCursor;
END.
